﻿Type=StaticCode
Version=3.82
B4A=true
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub


'//-------------------------------------------------------------------------------//
'//-       write M0 to M3                                                        -//		
'//-------------------------------------------------------------------------------//
Public Sub Tx_Write_M0_M3() 
    Dim data(1) As Byte
    Dim buf1_tx(10) As Byte 
    Dim j As Short,k As Short  
   
    data(0)=0
    For j=0 To 3
        k = global.tx_M_status(j)
        data(0) = Bit.OR(Bit.Shiftleft(k,j),data(0))
    Next
	
    CMD_15_RTU_Master(global.NetID,global.ADDRESS_M,4,data,buf1_tx)
  	global.myComm.AStreams.Write(buf1_tx)
 
End Sub



'//-------------------------------------------------------------------------------//
'//-       Write AM0 ~ AM1                                                          -//		
'//-------------------------------------------------------------------------------//
Public Sub Tx_Write_AM( index As Int )
	Dim buf1_tx(8) As Byte
    Dim data As Short  
	  
	data= global.tx_AM_data(index) 
	CMD_06_RTU_Master(global.NetID,global.ADDRESS_AM+index,data,buf1_tx)
	global.myComm.AStreams.Write(buf1_tx)
   
End Sub




'//-------------------------------------------------------------------------------//
'//-       Read M0 ~ M3                                                          -//		
'//-------------------------------------------------------------------------------//
Public Sub Tx_Read_M0_M3() 
    Dim buf1_tx(8) As Byte 
      
    CMD_01_RTU_Master(global.NetID,global.ADDRESS_Q,4,buf1_tx)  
	global.myComm.AStreams.Write(buf1_tx)
   
End Sub



'//-------------------------------------------------------------------------------//
'//-         Read AM0 ~ AM1                                                      -//		
'//-------------------------------------------------------------------------------//
Public Sub Tx_Read_AM0_AM1() 
    Dim buf1_tx(8) As Byte 
      
    CMD_03_RTU_Master(global.NetID,global.ADDRESS_AM,2,buf1_tx)  
	global.myComm.AStreams.Write(buf1_tx)
	
End Sub



'//-------------------------------------------------------------------------------//
'//-         Read AM10 ~ AM11                                                      -//		
'//-------------------------------------------------------------------------------//
Public Sub Tx_Read_AM10_AM11() 
    Dim buf1_tx(8) As Byte 
      
    CMD_03_RTU_Master(global.NetID,global.ADDRESS_AM+10,2,buf1_tx)  
	global.myComm.AStreams.Write(buf1_tx)
	
End Sub




'*********************************************************************************'


'//-------------------------------------------------------------------------------//
'//-  FUNCTION CODE 03 Read Register                                             -//		
'//-  Return :  data length of TX (Byte)                                         -//					
'//-------------------------------------------------------------------------------//
Public Sub CMD_03_RTU_Master(id As Byte,addr As Short,num As Short,buf() As Byte) 
	
      Dim tmp_length As Short  
	
      buf(0) = id 
      buf(1) = 0x03 
      buf(2) = Bit.AND(Bit.ShiftRight(addr,8),0xff)
      buf(3) = Bit.AND(addr,0xff) 
      buf(4) = Bit.AND(Bit.ShiftRight(num,8),0xff) 
      buf(5) = Bit.AND(num,0xff)
	  tmp_length = 6
      
      CRC16(buf,tmp_length)
       
End Sub 





'//-------------------------------------------------------------------------------//
'//-  FFUNCTION CODE 06 Set Registers                                            -//		
'//-  Return :  data length of TX (Byte)                                         -//					
'//-------------------------------------------------------------------------------//
Public Sub CMD_06_RTU_Master(id As Byte,addr As Short,data As Short, buf() As Byte) 
 	
      Dim length As Short

      buf(0) = id 
      buf(1) = 0x06 
      buf(2) = Bit.AND(Bit.ShiftRight(addr,8),0xff)
      buf(3) = Bit.AND(addr,0xff) 
      buf(4)= Bit.AND(Bit.ShiftRight(data,8),0xff)
	  buf(5)= Bit.AND(data,0xff)
      
      length = 6
      
      CRC16(buf,length) 
	
End Sub 




'//-------------------------------------------------------------------------------//
'//-  FFUNCTION CODE 16 Set Multi Registers                                      -//		
'//-  Return :  data length of TX (Byte)                                         -//					
'//-------------------------------------------------------------------------------//
Public Sub CMD_16_RTU_Master(id As Byte,addr As Short,num As Short, data()As Short, buf() As Byte) 
 	
      Dim length As Short
	  Dim i As Int 

      buf(0) = id 
      buf(1) = 0x10 
      buf(2) = Bit.AND(Bit.ShiftRight(addr,8),0xff)
      buf(3) = Bit.AND(addr,0xff) 
      buf(4) = Bit.AND(Bit.ShiftRight(num,8),0xff) 
      buf(5) = Bit.AND(num,0xff)
      buf(6) = num*2
              
      For i=0 To num-1        
         buf(7+i*2)= Bit.AND(Bit.ShiftRight(data(i),8),0xff)
		 buf(8+i*2)= Bit.AND(data(i),0xff)
      Next
      
      length = buf(6)+7
      
      CRC16(buf,length) 
	
End Sub 



'//-------------------------------------------------------------------------------//
'//-  FUNCTION CODE 01 Read coils                                                -//		
'//-  Return :  data length of TX (Byte)                                         -//					
'//-------------------------------------------------------------------------------//
Public Sub CMD_01_RTU_Master(id As Byte,addr As Short,num As Short,buf() As Byte)
	
      Dim tmp_length As Short  
	
      buf(0) = id 
      buf(1) = 0x01 
      buf(2) = Bit.AND(Bit.ShiftRight(addr,8),0xff)
      buf(3) = Bit.AND(addr,0xff) 
      buf(4) = Bit.AND(Bit.ShiftRight(num,8),0xff) 
      buf(5) = Bit.AND(num,0xff)
	  tmp_length = 6
      
      CRC16(buf,tmp_length)
	  
End Sub 



'//-------------------------------------------------------------------------------//
'//-  FFUNCTION CODE 15 Set Multi coils                                          -//		
'//-  Return :  data length of TX (Byte)                                         -//					
'//-------------------------------------------------------------------------------//
Public Sub CMD_15_RTU_Master(id As Byte,addr As Short,num As Short, data()As Byte, buf() As Byte)
 	
      Dim length As Short,value As Short
	  Dim i As Int 

      buf(0) = id 
      buf(1) = 0x0f 
      buf(2) = Bit.AND(Bit.ShiftRight(addr,8),0xff)
      buf(3) = Bit.AND(addr,0xff) 
      buf(4) = Bit.AND(Bit.ShiftRight(num,8),0xff) 
      buf(5) = Bit.AND(num,0xff)
      value = (num+7)/8          'byte count   '無條件進入法
	  buf(6) = value
              
      For i=0 To value-1        
         buf(7+i)= data(i)
      Next
      
      length = buf(6)+7
      
      CRC16(buf,length) 
	
End Sub 


'//******************************************************************************//
'//                                                                             *//
'//           2. MASTER Receive response anaylize from slave                    *//
'//                                                                             *//
'//******************************************************************************//




'//-------------------------------------------------------------------------------//
'//-   Master receive from Slave ( RTU )                                         -//		
'//-   Return :  0:correct   other: error                                        -//					
'//-------------------------------------------------------------------------------//
Public Sub  RTU_Response_Anlys_Master( src() As Byte , src_length As Short, data() As Short) As Int  

	Dim errorcode As Int   
	Dim clength As Short,i As Short
	Dim buf(src_length) As Byte 
	

    If(src_length<6) Then Return -1   ' check receive num (min)

	clength = src_length-2  
	For i=0 To clength-1
	    buf(i) = src(i)
	Next
	CRC16(buf,clength)

	If ( buf(clength)<> src(clength)) Then Return -1      ' check crc (low)
	If ( buf(clength+1)<> src(clength+1)) Then Return -1  ' check crc (hi)
	i = Bit.AND (src(1),0x80)
    If(i <> 0) Then  Return -1        ' check error code
	Select src(1)    ' Function Code
	    Case 0x01  : 
		     errorcode = Response_01_RTU_Master(src,clength,data)
			 If(errorcode >=0 ) Then
			     For i=0 To 3
			        global.rx_m_Status(i)= data(i)'Bit.AND(Bit.ShiftRight(data(0),i),0x01)
				 Next 
			 End If 
        Case 0x03  : 
			 errorcode = Response_03_RTU_Master(src,clength,data)
			 If(errorcode >=0 ) Then
                 If(global.index =5) Then
				    For i=0 To 1
			           global.rx_AM_data(i)= data(i)
				    Next 
		     	 Else If(global.index =0) Then
		            For i=0 To 1
			           global.rx_AM_data(2+i)= data(i)
				    Next 
				 End If
			 Else
			 End If 
		 Case 0x06  : 
		     errorcode = Response_06_RTU_Master(src,clength)	 
		Case 0x0f  : 
		     errorcode = Response_15_RTU_Master(src,clength)
	    Case 0x10  : 
		     errorcode = Response_16_RTU_Master(src,clength)
        Case Else  : 
		     errorcode = -1
    End Select	   
	     
    Return errorcode  
   
End Sub



'//-------------------------------------------------------------------------------//
'//-   func code 0x03 For master receive (from slave response)                   -//	
'//-   Return: 0:correct   other: error        			                         -//	
'//-------------------------------------------------------------------------------//
Public Sub Response_03_RTU_Master( src() As Byte,length As Short,data() As Short) As Short   

    Dim i As Int 
	Dim value1 As Long ,value2 As Long 
	
   	If length <> (src(2)+3) Then Return -1
	If src(0) <> global.NetID Then Return -1
	If src(1) <> 0x03 Then Return -1

    For i=0 To (src(2)/2)-1
	    value1 = Bit.AND(Bit.ShiftLeft(src(3+i*2),8),0xff00)
		value2 = Bit.AND(src(4+i*2),0x00ff)
        data(i)= Bit.OR(value1,value2)
	Next
	
    Return 0
	
End Sub


'//-------------------------------------------------------------------------------//
'//-   func code 0x06  For master receive (from slave response)                  -//	
'//-   Return: 0:correct   other: error        	   		                         -//	
'//-------------------------------------------------------------------------------//
Public Sub Response_06_RTU_Master( src() As Byte , length As Short) As Short  

    If length <> 6 Then Return -1
	If src(0) <> global.NetID Then Return -1
	If src(1) <> 6 Then Return -1
	
    Return 0
	
End Sub



'//-------------------------------------------------------------------------------//
'//-   func code 0x10  For master receive (from slave response)                  -//	
'//-   Return: 0:correct   other: error        	   		                         -//	
'//-------------------------------------------------------------------------------//
Public Sub Response_16_RTU_Master( src() As Byte , length As Short) As Short  

    If length <> 6 Then Return -1
	If src(0) <> global.NetID Then Return -1
	If src(1) <> 16 Then Return -1
	
    Return 0
	
End Sub




'//-------------------------------------------------------------------------------//
'//-   func code 0x01 For master receive (from slave response)                   -//	
'//-   Return: 0:correct   other: error        			                         -//	
'//-------------------------------------------------------------------------------//
Public Sub Response_01_RTU_Master( src() As Byte,length As Short,data() As Short) As Short   

    Dim i As Int, j As Int  
	Dim value As Short 
	
   	If length <> (src(2)+3) Then Return -1
	If src(0) <> global.NetID Then Return -1
	If src(1) <> 0x01 Then Return -1

    For i=0 To src(2)-1
	    For j=0 To 7
	        value = Bit.ShiftRight(src(3+i),j)
            data(i*8+j)= Bit.AND(value,0x01)
		Next 
	Next

	Return 0
	
End Sub



'//-------------------------------------------------------------------------------//
'//-   func code 0x0f  For master receive (from slave response)                  -//	
'//-   Return: 0:correct   other: error        	   		                         -//	
'//-------------------------------------------------------------------------------//
Public Sub Response_15_RTU_Master( src() As Byte , length As Short) As Short  

    If length <> 6 Then Return -1
	If src(0) <> global.NetID Then Return -1
	If src(1) <> 15 Then Return -1
	
    Return 0
	
End Sub

'//---------------------------------------------------------------------------//
'//-   CRC 16                                                                -//
'//-   add crc16 to buf ,  length : not include crc data                     -//
'//---------------------------------------------------------------------------//
Public Sub CRC16(buf() As Byte, length As Int ) 
      Dim CRC16Lo As Short, CRC16Hi As Short,buf2 As Short 
	  Dim CL As Short, CH As Short
	  Dim SaveHi As Short, SaveLo As Short
	  Dim i As Int, Flag As Int  

	  CRC16Lo = 0xff
	  CRC16Hi = 0xff
	  CL = 0x01
	  CH = 0xA0
	  
	  If length = 0 Then
	    CRC16Hi = 0
		CRC16Lo = 0
	  Else
	    For i = 0 To length-1
		  buf2=Bit.AND(buf(i),0xff)
	      CRC16Lo = Bit.Xor (CRC16Lo,buf2)
		  For Flag = 0 To 7
            SaveHi = CRC16Hi
		    SaveLo = CRC16Lo
            CRC16Hi = CRC16Hi/2
            CRC16Lo = CRC16Lo/2
		    If (Bit.AND(SaveHi,0x1) = 0x1) Then
		       CRC16Lo = Bit.OR(CRC16Lo,0x80)
		    End If
		    If (Bit.AND(SaveLo,0x01) = 0x01) Then
		       CRC16Hi = Bit.Xor(CRC16Hi,CH)
			   CRC16Lo = Bit.Xor(CRC16Lo,CL)
		    End If
		  Next
	    Next
	  End If
	  
	  buf(length)= CRC16Lo
	  buf(length+1)= CRC16Hi
	  
End Sub




